<?php

class WPvivid_backup_pro_function
{
    public function get_backup($files)
    {
        $backup_ids=array();
        foreach ($files as $file_data)
        {
            if(preg_match('/wpvivid-.*_.*_.*\.zip$/',$file_data['name']))
            {
                if(preg_match('/wpvivid-(.*?)_/',$file_data['name'],$matches))
                {
                    $id= $matches[0];
                    $id=substr($id,0,strlen($id)-1);

                    if(preg_match('/wpvivid-.*_.*_backup_all\.zip$/',$file_data['name'],$matches))
                    {
                        $backup_ids[$id]['type']='all';
                    }
                    else if(preg_match('/wpvivid-.*_.*_backup_db\.zip$/',$file_data['name'],$matches))
                    {
                        $backup_ids[$id][]['type']='db';
                    }
                    else if(preg_match('/wpvivid-.*_.*_backup_themes\.zip$/',$file_data['name'],$matches))
                    {
                        $backup_ids[$id][]['type']='themes';
                    }
                    else if(preg_match('/wpvivid-.*_.*_backup_plugin\.zip$/',$file_data['name'],$matches))
                    {
                        $backup_ids[$id][]['type']='plugin';
                    }
                    else if(preg_match('/wpvivid-.*_.*_backup_uploads\.zip$/',$file_data['name'],$matches))
                    {
                        $backup_ids[$id][]['type']='uploads';
                    }
                    else if(preg_match('/wpvivid-.*_.*_backup_uploads_other\.zip$/',$file_data['name'],$matches))
                    {
                        $backup_ids[$id][]['type']='uploads';
                    }
                    else if(preg_match('/wpvivid-.*_.*_backup_content\.zip$/',$file_data['name'],$matches))
                    {
                        $backup_ids[$id][]['type']='content';
                    }
                    else if(preg_match('/wpvivid-.*_.*_backup_core\.zip$/',$file_data['name'],$matches))
                    {
                        $backup_ids[$id][]['type']='core';
                    }
                    else
                    {
                        $backup_ids[$id][]['type']='unrecognized';
                    }

                    if(preg_match('/[0-9]{4}-[0-9]{2}-[0-9]{2}-[0-9]{2}-[0-9]{2}/',$file_data['name'],$matches))
                    {
                        $backup_ids[$id]['date']=$matches[0];
                    }
                    else
                    {
                        $backup_ids[$id]['date']='unrecognized';
                    }

                    if(!isset($backup_ids[$id]['backup_prefix']))
                    {
                        if(preg_match('#^.*_wpvivid-#',$file_data['name'],$matches))
                        {
                            $prefix=$matches[0];
                            $prefix=substr($prefix,0,strlen($prefix)-strlen('_wpvivid-'));
                            $backup_ids[$id]['backup_prefix']=$prefix;
                        }
                        else
                        {
                            $backup_ids[$id]['backup_prefix']='';
                        }
                    }

                    $backup_ids[$id]['files'][]=$file_data;
                }
            }
        }
        return $backup_ids;
    }

    public function rescan_remote_folder_set_backup($remote_id,$backups)
    {
        $remote_ids[]=$remote_id;
        $remote_options=WPvivid_Setting::get_remote_options($remote_ids);

        $remote_options_staging=array();
        $remote_options_migrate=array();
        $remote_options_rollback=array();
        foreach ($remote_options as $option)
        {
            $og_path=$option['path'];
            if(isset($option['custom_path']))
            {
                $og_custom_path=$option['custom_path'];
            }
            else
            {
                $og_custom_path='';
            }

            if(isset($option['custom_path']))
            {
                $option['custom_path']='staging';
                $remote_options_staging[]=$option;
            }
            else
            {
                $option['path']='staging';
                $remote_options_staging[]=$option;
            }

            if(isset($option['custom_path']))
            {
                $option['custom_path']='migrate';
                $remote_options_migrate[]=$option;
            }
            else
            {
                $option['path']='migrate';
                $remote_options_migrate[]=$option;
            }

            if(isset($option['custom_path']))
            {
                $option['custom_path']=$og_custom_path.'/rollback';
                $option['path']= $og_path;
                $remote_options_rollback[]=$option;
            }
            else
            {
                $option['path']= $og_path.'/rollback';
                $remote_options_rollback[]=$option;
            }
        }

        $list=array();
        if(!empty($backups['remote']))
        {
            foreach ($backups['remote'] as $id=>$backup)
            {
                $backup_data=array();
                $backup_data['type']='Common';
                $time_array=explode('-',$backup['date']);
                if(sizeof($time_array)>4)
                    $time=$time_array[0].'-'.$time_array[1].'-'.$time_array[2].' '.$time_array[3].':'.$time_array[4];
                else
                    $time=$backup['date'];
                $backup_data['create_time']=strtotime($time);
                $backup_data['manual_delete']=0;
                $backup_data['local']['path']=WPvivid_Setting::get_backupdir();
                $backup_data['compress']['compress_type']='zip';
                $backup_data['save_local']=0;
                $backup_data['backup_prefix']=$backup['backup_prefix'];

                global $wpvivid_plugin;
                $wpvivid_plugin->wpvivid_log=new WPvivid_Log();
                $wpvivid_plugin->wpvivid_log->CreateLogFile($id.'_backup','no_folder','backup');
                $wpvivid_plugin->wpvivid_log->WriteLogHander();
                $wpvivid_plugin->wpvivid_log->WriteLog('Upload finished.','notice');

                $backup_data['log']=$wpvivid_plugin->wpvivid_log->log_file;

                $temp['result']='success';
                $temp['files']=array();
                foreach ($backup['files'] as $file)
                {
                    $add_file['file_name']=$file['name'];
                    $add_file['size']=$file['size'];
                    $temp['files'][]=$add_file;
                }

                $backup_data['backup']=$temp;
                $backup_data['remote']=$remote_options;
                $backup_data['lock']=0;
                $list[$id]=$backup_data;
            }
        }

        if(!empty($backups['staging']))
        {
            foreach ($backups['staging'] as $id=>$backup)
            {
                $backup_data=array();
                $backup_data['type']='Staging';
                $time_array=explode('-',$backup['date']);
                if(sizeof($time_array)>4)
                    $time=$time_array[0].'-'.$time_array[1].'-'.$time_array[2].' '.$time_array[3].':'.$time_array[4];
                else
                    $time=$backup['date'];
                $backup_data['create_time']=strtotime($time);
                $backup_data['manual_delete']=0;
                $backup_data['local']['path']=WPvivid_Setting::get_backupdir();
                $backup_data['compress']['compress_type']='zip';
                $backup_data['save_local']=0;
                $backup_data['backup_prefix']=$backup['backup_prefix'];

                global $wpvivid_plugin;
                $wpvivid_plugin->wpvivid_log=new WPvivid_Log();
                $wpvivid_plugin->wpvivid_log->CreateLogFile($id.'_backup','no_folder','backup');
                $wpvivid_plugin->wpvivid_log->WriteLogHander();
                $wpvivid_plugin->wpvivid_log->WriteLog('Upload finished.','notice');

                $backup_data['log']=$wpvivid_plugin->wpvivid_log->log_file;

                $temp['result']='success';
                $temp['files']=array();
                foreach ($backup['files'] as $file)
                {
                    $add_file['file_name']=$file['name'];
                    $add_file['size']=$file['size'];
                    $temp['files'][]=$add_file;
                }

                $backup_data['backup']=$temp;
                $backup_data['remote']=$remote_options_staging;
                $backup_data['lock']=0;
                $list[$id]=$backup_data;
            }
        }

        if(!empty($backups['migrate']))
        {
            foreach ($backups['migrate'] as $id=>$backup)
            {
                $backup_data=array();
                $backup_data['type']='Migrate';
                $time_array=explode('-',$backup['date']);
                if(sizeof($time_array)>4)
                    $time=$time_array[0].'-'.$time_array[1].'-'.$time_array[2].' '.$time_array[3].':'.$time_array[4];
                else
                    $time=$backup['date'];
                $backup_data['create_time']=strtotime($time);
                $backup_data['manual_delete']=0;
                $backup_data['local']['path']=WPvivid_Setting::get_backupdir();
                $backup_data['compress']['compress_type']='zip';
                $backup_data['save_local']=0;
                $backup_data['backup_prefix']=$backup['backup_prefix'];

                global $wpvivid_plugin;
                $wpvivid_plugin->wpvivid_log=new WPvivid_Log();
                $wpvivid_plugin->wpvivid_log->CreateLogFile($id.'_backup','no_folder','backup');
                $wpvivid_plugin->wpvivid_log->WriteLogHander();
                $wpvivid_plugin->wpvivid_log->WriteLog('Upload finished.','notice');

                $backup_data['log']=$wpvivid_plugin->wpvivid_log->log_file;

                $temp['result']='success';
                $temp['files']=array();
                foreach ($backup['files'] as $file)
                {
                    $add_file['file_name']=$file['name'];
                    $add_file['size']=$file['size'];
                    $temp['files'][]=$add_file;
                }

                $backup_data['backup']=$temp;
                $backup_data['remote']=$remote_options_migrate;
                $backup_data['lock']=0;
                $list[$id]=$backup_data;
            }
        }

        if(!empty($backups['rollback']))
        {
            foreach ($backups['rollback'] as $id=>$backup)
            {
                $backup_data=array();
                $backup_data['type']='Rollback';
                $time_array=explode('-',$backup['date']);
                if(sizeof($time_array)>4)
                    $time=$time_array[0].'-'.$time_array[1].'-'.$time_array[2].' '.$time_array[3].':'.$time_array[4];
                else
                    $time=$backup['date'];
                $backup_data['create_time']=strtotime($time);
                $backup_data['manual_delete']=0;
                $backup_data['local']['path']=WPvivid_Setting::get_backupdir();
                $backup_data['compress']['compress_type']='zip';
                $backup_data['save_local']=0;
                $backup_data['backup_prefix']=$backup['backup_prefix'];

                global $wpvivid_plugin;
                $wpvivid_plugin->wpvivid_log=new WPvivid_Log();
                $wpvivid_plugin->wpvivid_log->CreateLogFile($id.'_backup','no_folder','backup');
                $wpvivid_plugin->wpvivid_log->WriteLogHander();
                $wpvivid_plugin->wpvivid_log->WriteLog('Upload finished.','notice');

                $backup_data['log']=$wpvivid_plugin->wpvivid_log->log_file;

                $temp['result']='success';
                $temp['files']=array();
                foreach ($backup['files'] as $file)
                {
                    $add_file['file_name']=$file['name'];
                    $add_file['size']=$file['size'];
                    $temp['files'][]=$add_file;
                }

                $backup_data['backup']=$temp;
                $backup_data['remote']=$remote_options_rollback;
                $backup_data['lock']=0;
                $list[$id]=$backup_data;
            }
        }
        WPvivid_Setting::update_option('wpvivid_remote_list',$list);
    }

    public function get_old_backup_files($backups,$count)
    {
        $size=sizeof($backups);

        $files=array();

        while($size>$count)
        {
            $oldest_id='not set';
            $oldest=0;
            foreach ($backups as $k=>$backup)
            {
                $time_array=explode('-',$backup['date']);
                if(sizeof($time_array)>4)
                    $time=$time_array[0].'-'.$time_array[1].'-'.$time_array[2].' '.$time_array[3].':'.$time_array[4];
                else
                    $time=$backup['date'];
                $backup_time=strtotime($time);
                if($oldest==0)
                {
                    $oldest=$backup_time;
                    $oldest_id=$k;
                }
                else
                {
                    if($oldest>$backup_time)
                    {
                        $oldest_id=$k;
                    }
                }
            }

            if($oldest_id!='not set')
            {
                foreach ($backups[$oldest_id]['files'] as $file)
                {
                    $files[]=$file['name'];
                }
                unset($backups[$oldest_id]);
            }
            $new_size=sizeof($backups);
            if($new_size==$size)
            {
                break;
            }
            else
            {
                $size=$new_size;
            }
        }

        return $files;
    }

    public function swtich_domain_to_folder_name($domain){
        $parse = parse_url($domain);
        $path = '';
        if(isset($parse['path'])) {
            $parse['path'] = str_replace('/', '_', $parse['path']);
            $parse['path'] = str_replace('.', '_', $parse['path']);
            $path = $parse['path'];
        }
        $parse['host'] = str_replace('/', '_', $parse['host']);
        $parse['host'] = str_replace('.', '_', $parse['host']);
        return $parse['host'].$path;
    }
}