<?php

class WPvivid_backup_pro
{
    public $addons;
    public $func;

    public function __construct()
    {
        include_once WPVIVID_BACKUP_PRO_PLUGIN_DIR.'/includes/class-wpvivid-connect-server.php';
        include_once WPVIVID_BACKUP_PRO_PLUGIN_DIR . '/includes/class-wpvivid-backup-pro-function.php';
        include_once WPVIVID_BACKUP_PRO_PLUGIN_DIR . '/includes/class-wpvivid-backup-pro-addon-loader.php';
        include_once WPVIVID_BACKUP_PRO_PLUGIN_DIR .'/includes/class-wpvivid-remote-addon.php';
        include_once WPVIVID_BACKUP_PRO_PLUGIN_DIR.'/includes/class-wpvivid-custom-interface-addon.php';

        if(!file_exists(WPVIVID_BACKUP_PRO_PLUGIN_DIR.'/addons/class-wpvivid-multisite.php'))
        {
            if(!class_exists('WPvivid_multisite'))
            {
                if (is_multisite())
                {
                    //add_action('init', array($this, 'init'));
                    add_filter('wpvivid_get_screen_ids', array($this, 'get_network_screen_ids'),99);
                    add_filter('wpvivid_get_toolbar_menus', array($this, 'get_network_toolbar_menus'),99);
                    add_filter('wpvivid_get_admin_url',array($this,'get_network_admin_url'),11);
                }
            }
        }

        $this->func=new WPvivid_backup_pro_function();
        $this->addons=new WPvivid_backup_pro_addon_loader();

        $this->addons->load_local_addon();

        add_action('wp_ajax_wpvivid_connect_account_and_active',array( $this,'connect_account_and_active'));
        add_action('wp_ajax_wpvivid_connect_account',array( $this,'connect_account'));
        //
        add_action('wp_ajax_wpvivid_check_pro_update',array($this,'check_pro_update'));
        add_action('wp_ajax_wpvivid_active_site',array( $this,'active_site'));
        add_action('wp_ajax_wpvivid_update_addon',array( $this,'update_addon'));
        add_action('wp_ajax_wpvivid_update_all',array( $this,'update_all'));

        add_action('wp_ajax_wpvivid_get_service_key',array( $this,'get_key'));

        add_filter('wpvivid_add_tab_page', array($this, 'add_addon_tab_page'), 12);

        add_action('wpvivid_pro_update_event',array( $this,'check_pro_update_event'));

        add_action('admin_enqueue_scripts', array($this, 'enqueue_styles'), 11);
        add_action('admin_enqueue_scripts', array($this, 'enqueue_scripts'), 11);


        add_filter('wpvivid_get_screen_ids',array($this,'get_screen_ids'),11);
        add_filter('wpvivid_get_toolbar_menus',array($this,'get_toolbar_menus'),20);
        add_filter('wpvivid_get_admin_menus',array($this,'get_admin_menus'),20);
        add_filter('wpvivid_set_page_request',array($this,'set_page_request'),10);
        add_filter('wpvivid_get_admin_url',array($this,'get_admin_url'),10);
        add_action('wp_ajax_wpvivid_add_active_info',array( $this,'add_active_info'));
        add_action('admin_notices', array($this, 'check_wpvivid_plugin_active'));

        add_filter('wpvivid_display_pro_name', array($this, 'display_pro_name'), 11);
        add_filter('wpvivid_display_pro_version', array($this, 'display_pro_version'), 11);
        add_filter('wpvivid_join_pro_testing', array($this, 'wpvivid_join_pro_testing'), 11);

        //
       // add_action( 'in_plugin_update_message-wp-mail-smtp/wp_mail_smtp.php', array($this, 'show_update_notices'), 10, 2 );
        $user_info=$this->get_user_info();
        if($user_info!==false)
        {
            $addons_cache=$this->get_addons_cache();
            if($addons_cache!==false)
            {
                if($addons_cache['pro_user']==1)
                {
                    if($addons_cache['check_active'])
                    {
                        if(version_compare(WPVIVID_BACKUP_PRO_VERSION,$addons_cache['pro']['version'],'<'))
                        {
                            add_action( 'admin_notices', array($this,'show_update_notices'));
                        }
                    }
                }
            }
        }

        $this->check_update_schedule();
    }

    public static function get_network_admin_url($admin_url)
    {
        if (is_multisite())
        {
            return network_admin_url();
        }
        else
        {
            return admin_url();
        }
    }

    public function get_network_screen_ids($screen_ids)
    {
        if(is_multisite())
        {
            $new_screen_ids=array();
            foreach ($screen_ids as $screen_id)
            {
                if(substr($screen_id,-8)=='-network')
                    continue;
                $new_screen_ids[]=$screen_id.'-network';
            }
            return $new_screen_ids;
        }
        else
        {
            return $screen_ids;
        }
    }

    public function get_network_toolbar_menus($toolbar_menus)
    {
        if(is_multisite())
        {
            $new_toolbar_menus=array();
            $admin_url = network_admin_url();
            foreach ($toolbar_menus as $menu)
            {
                if(isset($menu['child']))
                {
                    foreach ($menu['child'] as $child_menu)
                    {
                        $child_menu['href']=$admin_url. $child_menu['tab'];
                        $menu['child'][$child_menu['id']]=$child_menu;
                    }
                }
                $new_toolbar_menus[$menu['id']]=$menu;
            }
            return $new_toolbar_menus;
        }
        else
        {
            return $toolbar_menus;
        }
    }

    public function display_pro_name($display_name){
        $display_name = 'WPvivid Backup Pro';
        return $display_name;
    }

    public function display_pro_version($display_version){
        $display_version = WPVIVID_BACKUP_PRO_VERSION;
        return $display_version;
    }

    public function wpvivid_join_pro_testing($html){
        $html = '';
        return $html;
    }

    public function get_admin_url($admin_url)
    {
        return admin_url();
    }

    public function show_update_notices()
    {
        $addons_cache=$this->get_addons_cache();
        if($addons_cache!==false)
        {
            $version=$addons_cache['pro']['version'];
            $message='<div class="notice inline notice-warning is-dismissible" style="padding: 11px 15px; margin: 10px 20px 10px 2px;">';
            $message.='There is a new version of WPvivid Backup Pro available.Version '.$version.' <a href="'.admin_url().'admin.php?page=wpvivid-pro'.'">update now</a></div>';
            echo wp_kses_post( $message );
        }
    }

    public function get_screen_ids($screen_ids)
    {
        $screen_ids[]='wpvivid-backup_page_wpvivid-pro';
        return $screen_ids;
    }

    public function set_page_request($request_page)
    {
        if(isset($_REQUEST['tab-pro']))
        {
            $request_page='wpvivid_tab_pro';
        }
        //tab-pro
        return $request_page;
    }

    public function get_toolbar_menus($toolbar_menus)
    {
        $admin_url = apply_filters('wpvivid_get_admin_url', '');

        $menu['id']='wpvivid_admin_menu_pro';
        $menu['parent']='wpvivid_admin_menu';
        $menu['title']='Pro';
        $menu['tab']= 'admin.php?page=WPvivid&tab-pro';
        $menu['href']=$admin_url . 'admin.php?page=WPvivid&tab-pro';
        $menu['index']=9;
        $toolbar_menus[$menu['parent']]['child'][$menu['id']]=$menu;
        return $toolbar_menus;
    }

    public function get_admin_menus($submenus)
    {
        $submenu['parent_slug']=WPVIVID_PLUGIN_SLUG;
        $submenu['page_title']= __('WPvivid Backup');
        $submenu['menu_title']=__('Pro', 'wpvivid');
        $submenu['capability']='administrator';
        $submenu['menu_slug']='wpvivid-pro';
        $submenu['index']=9;
        $submenu['function']=array($this, 'display_plugin_pro_page');
        $submenus[$submenu['menu_slug']]=$submenu;
        return $submenus;
    }

    public function display_plugin_pro_page()
    {
        global $request_page,$wpvivid_plugin;
        $request_page='wpvivid_tab_pro';
        $wpvivid_plugin->admin->display_plugin_setup_page();
    }

    public function check_update_schedule()
    {
        if(!defined( 'DOING_CRON' ))
        {
            if(wp_get_schedule('wpvivid_pro_update_event')===false)
            {
                if(wp_schedule_event(time()+30, 'daily', 'wpvivid_pro_update_event')===false)
                {
                    return false;
                }
            }
        }

        return true;
    }

    public function check_pro_update_event()
    {
        try
        {
            $info=$this->get_user_info();
            if($info===false)
            {
                die();
            }

            $server=new WPvivid_Connect_server();
            $ret=$server->login($info['password'],false);

            if($ret['result']=='success')
            {
                $this->update_addons_cache($ret['status']);

                update_option('wpvivid_last_update_time',time());
            }
            else
            {
                $this->update_addons_cache(array());

                update_option('wpvivid_last_update_time',time());
            }
        }
        catch (Exception $e)
        {
        }
        die();
    }

    public function enqueue_styles()
    {
        $screen_ids=array();
        $screen_ids=apply_filters('wpvivid_get_screen_ids',$screen_ids);
        if(in_array(get_current_screen()->id,$screen_ids))
        {
            wp_enqueue_style(WPVIVID_PLUGIN_SLUG.'jstree', WPVIVID_BACKUP_PRO_PLUGIN_URL . 'includes/js/jstree/dist/themes/default/style.min.css', array(), WPVIVID_BACKUP_PRO_VERSION, 'all');
            wp_enqueue_style(WPVIVID_PLUGIN_SLUG.'addon', WPVIVID_BACKUP_PRO_PLUGIN_URL . 'includes/css/wpvivid-backup-custom.css', array(), WPVIVID_BACKUP_PRO_VERSION, 'all');
        }
    }

    public function enqueue_scripts()
    {
        $screen_ids=array();
        $screen_ids=apply_filters('wpvivid_get_screen_ids',$screen_ids);
        if(in_array(get_current_screen()->id,$screen_ids))
        {
            wp_enqueue_script(WPVIVID_PLUGIN_SLUG.'jstree', WPVIVID_BACKUP_PRO_PLUGIN_URL . 'includes/js/jstree/dist/jstree.min.js', array('jquery'), WPVIVID_BACKUP_PRO_VERSION, false);
        }
    }

    public function add_addon_tab_page($page_array)
    {
        $page_array['pro'] = array('index' => '10', 'tab_func' => array($this, 'add_addon_tab'), 'page_func' => array($this, 'init_page'));
        $page_array['key']['index'] = '9';
        $page_array['key']['page_func'] = array($this, 'wpvivid_add_page_key');
        $page_array['read_log']['index']='20';
        return $page_array;
    }

    public function wpvivid_add_page_key(){
        ?>
        <div id="key-page" class="wrap-tab-content wpvivid_tab_key" name="tab-key" style="display: none;">
            <div class="postbox quickbackup-addon">
                <div>
                    <div class="wpvivid-element-space-bottom">
                        In order to allow another site to send a backup to this site, please generate a key below. Once the key is generated, this site is ready to receive a backup from another site. Then, please copy and paste the key in sending site and save it.
                    </div>
                    <div class="wpvivid-element-space-bottom">
                    <strong><?php _e('The key will expire in ', 'wpvivid'); ?></strong>
                    <select id="wpvivid_generate_url_expires" style="margin-bottom: 2px;">
                        <option value="2 hour">2 hours</option>
                        <option selected="selected" value="8 hour">8 hours</option>
                        <option value="24 hour">24 hours</option>
                        <!--<option value="Never">Never</option>-->
                    </select>
                    </div>
                    <div class="wpvivid-element-space-bottom"><strong>Tips:</strong> For security reason, please choose an appropriate expiration time for the key.</div>
                    <div class="wpvivid-element-space-bottom">
                        <input class="button-primary" id="wpvivid_generate_url" type="submit" value="<?php esc_attr_e( 'Generate', 'wpvivid' ); ?>" onclick="wpvivid_click_generate_url();" />
                    </div>
                    <div id="wpvivid_test_generate_url">
                        <textarea id="wpvivid_test_remote_site_url_text" style="width: 100%; height: 140px;"></textarea>
                    </div>
                </div>
            </div>
        </div>
        <script>
            jQuery("#wpvivid_test_remote_site_url_text").focus(function() {
                jQuery(this).select();
                jQuery(this).mouseup(function() {
                    jQuery(this).unbind("mouseup");
                    return false;
                });
            });
            function wpvivid_click_generate_url()
            {
                var expires=jQuery('#wpvivid_generate_url_expires').val();
                var ajax_data = {
                    'action': 'wpvivid_generate_url',
                    'expires':expires
                };
                wpvivid_post_request(ajax_data, function (data)
                {
                    jQuery('#wpvivid_test_remote_site_url_text').val(data);
                }, function (XMLHttpRequest, textStatus, errorThrown)
                {
                    var error_message = wpvivid_output_ajaxerror('generating key', textStatus, errorThrown);
                    alert(error_message);
                });
            }
        </script>
        <?php
    }

    public function init_page()
    {
        ?>

        <script>
            var wpvivid_need_update_addons = [];

            function wpvivid_connect_account(auto_login)
            {

                if(auto_login)
                {
                    var ajax_data={
                        'action':'wpvivid_connect_account',
                        'auto_login':true
                    };
                }
                else
                {
                    var value1 = jQuery('#wpvivid_account_user').val();
                    var value2 = jQuery('#wpvivid_account_pw').val();
                    var ajax_data={
                        'action':'wpvivid_connect_account',
                        'user':value1,
                        'password':value2,
                        'auto_login':false
                    };
                }
                jQuery('#wpvivid_login_box_progress').show();
                jQuery('#wpvivid_login_box_progress').addClass('is-active');
                jQuery('#wpvivid_connect_result').hide();
                jQuery('#wpvivid_connect_result').html('');
                jQuery('#wpvivid_active_btn').css({'pointer-events': 'none', 'opacity': '0.4'});
                wpvivid_post_request(ajax_data, function(data)
                {
                    jQuery('#wpvivid_active_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                    jQuery('#wpvivid_login_box_progress').hide();
                    jQuery('#wpvivid_login_box_progress').removeClass('is-active');
                    var jsonarray = jQuery.parseJSON(data);
                    if (jsonarray.result === 'success')
                    {
                        location.href='<?php echo apply_filters('wpvivid_get_admin_url', '') . 'admin.php?page=wpvivid-pro'?>';
                    }
                    else {
                        jQuery('#wpvivid_connect_result').show();
                        jQuery('#wpvivid_connect_result').html(jsonarray.error);
                    }
                }, function(XMLHttpRequest, textStatus, errorThrown)
                {
                    jQuery('#wpvivid_active_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                    jQuery('#wpvivid_login_box_progress').hide();
                    jQuery('#wpvivid_login_box_progress').removeClass('is-active');
                    jQuery('#wpvivid_connect_result').hide();
                    jQuery('#wpvivid_connect_result').html('');
                    var error_message = wpvivid_output_ajaxerror('init page', textStatus, errorThrown);
                    alert(error_message);
                });
            }

            function wpvivid_connect_account_and_active()
            {
                var value1 = jQuery('#wpvivid_account_user').val();
                var value2 = jQuery('#wpvivid_account_pw').val();
                var ajax_data={
                    'action':'wpvivid_connect_account',
                    'user':value1,
                    'password':value2,
                    'auto_login':false
                };
                jQuery('#wpvivid_login_box_progress').show();
                jQuery('#wpvivid_login_box_progress').addClass('is-active');
                jQuery('#wpvivid_connect_result').hide();
                jQuery('#wpvivid_connect_result').html('');
                jQuery('#wpvivid_log_progress_text').html('Logging in to your WPvivid Backup Pro account');
                jQuery('#wpvivid_active_btn').css({'pointer-events': 'none', 'opacity': '0.4'});
                wpvivid_post_request(ajax_data, function(data)
                {
                    var jsonarray = jQuery.parseJSON(data);
                    if (jsonarray.result === 'success')
                    {
                        if(jsonarray.pro_user===1)
                        {
                            if(jsonarray.check_active===1)
                            {
                                if(jsonarray.need_update===1||jsonarray.need_install===1)
                                {
                                    wpvivid_connect_update_all();
                                }
                                else
                                {
                                    jQuery('#wpvivid_active_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                                    jQuery('#wpvivid_login_box_progress').hide();
                                    jQuery('#wpvivid_login_box_progress').removeClass('is-active');
                                    jQuery('#wpvivid_log_progress_text').html('You have successfully logged in');
                                    location.href='<?php echo apply_filters('wpvivid_get_admin_url', '') . 'admin.php?page=wpvivid-pro'?>';
                                }
                            }
                            else
                            {
                                wpvivid_connect_active_site();
                            }
                        }
                        else
                        {
                            jQuery('#wpvivid_log_progress_text').html('You have successfully logged in');
                            location.href='<?php echo apply_filters('wpvivid_get_admin_url', '') . 'admin.php?page=wpvivid-pro'?>';
                        }
                    }
                    else {
                        jQuery('#wpvivid_active_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                        jQuery('#wpvivid_login_box_progress').hide();
                        jQuery('#wpvivid_login_box_progress').removeClass('is-active');
                        jQuery('#wpvivid_log_progress_text').html('');
                        jQuery('#wpvivid_connect_result').show();
                        jQuery('#wpvivid_connect_result').html(jsonarray.error);
                    }
                }, function(XMLHttpRequest, textStatus, errorThrown)
                {
                    jQuery('#wpvivid_log_progress_text').html('');
                    jQuery('#wpvivid_active_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                    jQuery('#wpvivid_login_box_progress').hide();
                    jQuery('#wpvivid_login_box_progress').removeClass('is-active');
                    jQuery('#wpvivid_connect_result').hide();
                    jQuery('#wpvivid_connect_result').html('');
                    var error_message = wpvivid_output_ajaxerror('connect server and active', textStatus, errorThrown);
                    alert(error_message);
                });
            }

            function wpvivid_connect_update_all()
            {
                var ajax_data={
                    'action':'wpvivid_update_all'
                };
                jQuery('#wpvivid_log_progress_text').html('Updating WPvivid Backup Pro...');
                wpvivid_post_request(ajax_data, function(data)
                {
                    jQuery('#wpvivid_active_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                    jQuery('#wpvivid_login_box_progress').hide();
                    jQuery('#wpvivid_login_box_progress').removeClass('is-active');
                    var jsonarray = jQuery.parseJSON(data);
                    if (jsonarray.result === 'success')
                    {
                        jQuery('#wpvivid_log_progress_text').html('Update completed successfully!');
                        location.href='<?php echo apply_filters('wpvivid_get_admin_url', '') . 'admin.php?page=wpvivid-pro'?>';
                    }
                    else {
                        jQuery('#wpvivid_log_progress_text').html('');
                        jQuery('#wpvivid_connect_result').show();
                        jQuery('#wpvivid_connect_result').html(jsonarray.error);
                    }
                }, function(XMLHttpRequest, textStatus, errorThrown)
                {
                    jQuery('#wpvivid_log_progress_text').html('');
                    jQuery('#wpvivid_active_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                    jQuery('#wpvivid_login_box_progress').hide();
                    jQuery('#wpvivid_login_box_progress').removeClass('is-active');
                    jQuery('#wpvivid_connect_result').hide();
                    jQuery('#wpvivid_connect_result').html('');
                    var error_message = wpvivid_output_ajaxerror('updating', textStatus, errorThrown);
                    alert(error_message);
                });
            }

            function wpvivid_connect_active_site()
            {
                var ajax_data={
                    'action':'wpvivid_active_site',
                };
                jQuery('#wpvivid_log_progress_text').html('Activating your license on the current site');
                wpvivid_post_request(ajax_data, function(data)
                {
                    jQuery('#wpvivid_active_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                    jQuery('#wpvivid_login_box_progress').hide();
                    jQuery('#wpvivid_login_box_progress').removeClass('is-active');
                    var jsonarray = jQuery.parseJSON(data);
                    if (jsonarray.result === 'success')
                    {
                        jQuery('#wpvivid_log_progress_text').html('Your license has been activated successfully');
                        location.href='<?php echo apply_filters('wpvivid_get_admin_url', '') . 'admin.php?page=wpvivid-pro'?>';
                    }
                    else {
                        jQuery('#wpvivid_log_progress_text').html('');
                        jQuery('#wpvivid_connect_result').show();
                        jQuery('#wpvivid_connect_result').html(jsonarray.error);
                    }
                }, function(XMLHttpRequest, textStatus, errorThrown)
                {
                    jQuery('#wpvivid_log_progress_text').html('');
                    jQuery('#wpvivid_active_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                    jQuery('#wpvivid_login_box_progress').hide();
                    jQuery('#wpvivid_login_box_progress').removeClass('is-active');
                    jQuery('#wpvivid_connect_result').hide();
                    jQuery('#wpvivid_connect_result').html('');
                    var error_message = wpvivid_output_ajaxerror('active site', textStatus, errorThrown);
                    alert(error_message);
                });
            }

            function wpvivid_change_user()
            {
                var descript = 'Are you sure swtich accounts?';
                var ret = confirm(descript);
                if(ret === true){
                    jQuery('#wpvivid_login_box').show();
                    jQuery('#wpvivid_userinfo_box').hide();
                }
            }

            function wpvivid_back_to_userinfo()
            {
                jQuery('#wpvivid_login_box').hide();
                jQuery('#wpvivid_userinfo_box').show();
            }

            function wpvivid_is_checking(is_checking){
                if(is_checking){
                    jQuery('#wpvivid_refresh_user_info').css({'pointer-events': 'none', 'opacity': '0.4'});
                    jQuery('#wpvivid_check_pro_update_btn').css({'pointer-events': 'none', 'opacity': '0.4'});
                    jQuery('#wpvivid_change_btn').css({'pointer-events': 'none', 'opacity': '0.4'});
                    jQuery('#wpvivid_active_btn').css({'pointer-events': 'none', 'opacity': '0.4'});
                    jQuery('#wpvivid_update_all_btn').css({'pointer-events': 'none', 'opacity': '0.4'});
                    jQuery('#wpvivid_active_site_btn').css({'pointer-events': 'none', 'opacity': '0.4'});
                }
                else{
                    jQuery('#wpvivid_refresh_user_info').css({'pointer-events': 'auto', 'opacity': '1'});
                    jQuery('#wpvivid_check_pro_update_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                    jQuery('#wpvivid_change_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                    jQuery('#wpvivid_active_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                    jQuery('#wpvivid_update_all_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                    jQuery('#wpvivid_active_site_btn').css({'pointer-events': 'auto', 'opacity': '1'});
                }
            }

            function wpvivid_check_pro_update()
            {
                var ajax_data={
                    'action':'wpvivid_check_pro_update',
                };
                wpvivid_is_checking(true);
                jQuery('#wpvivid_user_info_box_progress').addClass('is-active');
                wpvivid_post_request(ajax_data, function(data)
                {
                    wpvivid_is_checking(false);
                    jQuery('#wpvivid_user_info_box_progress').removeClass('is-active');
                    var jsonarray = jQuery.parseJSON(data);
                    if (jsonarray.result === 'success')
                    {
                        location.href='<?php echo apply_filters('wpvivid_get_admin_url', '') . 'admin.php?page=wpvivid-pro'?>';
                    }
                    else {
                        location.href='<?php echo apply_filters('wpvivid_get_admin_url', '') . 'admin.php?page=wpvivid-pro'?>';
                    }
                }, function(XMLHttpRequest, textStatus, errorThrown)
                {
                    wpvivid_is_checking(false);
                    jQuery('#wpvivid_user_info_box_progress').removeClass('is-active');
                    jQuery('#wpvivid_connect_result').hide();
                    jQuery('#wpvivid_connect_result').html('');
                    var error_message = wpvivid_output_ajaxerror('check update', textStatus, errorThrown);
                    alert(error_message);
                });
            }

            function wpvivid_click_update_all()
            {
                var ajax_data={
                    'action':'wpvivid_update_all'
                };
                wpvivid_is_checking(true);
                jQuery('#wpvivid_user_info_box_progress').addClass('is-active');
                wpvivid_post_request(ajax_data, function(data)
                {
                    wpvivid_is_checking(false);
                    jQuery('#wpvivid_user_info_box_progress').removeClass('is-active');
                    var jsonarray = jQuery.parseJSON(data);
                    if (jsonarray.result === 'success')
                    {
                        location.href='<?php echo apply_filters('wpvivid_get_admin_url', '') . 'admin.php?page=wpvivid-pro'?>';
                    }
                    else {
                        jQuery('#wpvivid_action_result').show();
                        jQuery('#wpvivid_action_result').html(jsonarray.error);
                    }
                }, function(XMLHttpRequest, textStatus, errorThrown)
                {
                    wpvivid_is_checking(false);
                    jQuery('#wpvivid_user_info_box_progress').removeClass('is-active');
                    jQuery('#wpvivid_action_result').hide();
                    jQuery('#wpvivid_action_result').html('');
                    var error_message = wpvivid_output_ajaxerror('updating', textStatus, errorThrown);
                    alert(error_message);
                });

            }

            function wpvivid_active_site()
            {
                var ajax_data={
                    'action':'wpvivid_active_site',
                };
                wpvivid_is_checking(true);
                jQuery('#wpvivid_user_info_box_progress').addClass('is-active');
                wpvivid_post_request(ajax_data, function(data)
                {
                    wpvivid_is_checking(true);
                    jQuery('#wpvivid_user_info_box_progress').removeClass('is-active');
                    var jsonarray = jQuery.parseJSON(data);
                    if (jsonarray.result === 'success')
                    {
                        location.href='<?php echo apply_filters('wpvivid_get_admin_url', '') . 'admin.php?page=wpvivid-pro'?>';
                    }
                    else {
                        jQuery('#wpvivid_action_result').show();
                        jQuery('#wpvivid_action_result').html(jsonarray.error);
                    }
                }, function(XMLHttpRequest, textStatus, errorThrown)
                {
                    wpvivid_is_checking(true);
                    jQuery('#wpvivid_user_info_box_progress').removeClass('is-active');
                    jQuery('#wpvivid_action_result').hide();
                    jQuery('#wpvivid_action_result').html('');
                    var error_message = wpvivid_output_ajaxerror('active site', textStatus, errorThrown);
                    alert(error_message);
                });
            }

            function wpvivid_add_active_info(name)
            {
                if(name=='active-now')
                {
                    wpvivid_click_switch_page('wrap', 'wpvivid_tab_pro', false);
                }
                var ajax_data={
                    'action': 'wpvivid_add_active_info',
                    'active-action': name
                };
                jQuery('#wpvivid_notice_rate').hide();
                wpvivid_post_request(ajax_data, function(res)
                {
                }, function(XMLHttpRequest, textStatus, errorThrown)
                {
                });
            }

            jQuery(document).ready(function ()
            {
                jQuery('input[option=wpvivid-active]').click(function()
                {
                    var name = jQuery(this).prop('name');
                    wpvivid_add_active_info(name);
                });
            });

        </script>
        <div id="pro-page" class="wrap-tab-content wpvivid_tab_pro" style="display: none;">
        <?php

        $last_error=get_option('wpvivid_connect_server_last_error',false);
        if($last_error!==false)
        {
            _e('<div class="notice notice-error is-dismissible"><p>'.$last_error.'</p></div>');
            delete_option('wpvivid_connect_server_last_error');
        }
        $addons_cache=false;
        $user_info=$this->get_user_info();
        if($user_info===false)
        {
            $this->output_login_box($user_info,false);
        }
        else
        {
            $addons_cache=$this->get_addons_cache();
            if($addons_cache===false)
            {
                $this->output_login_box($user_info,true);
            }
            else
            {
                $this->output_login_box($user_info,false);
                $this->output_userinfo($user_info,$addons_cache);
            }
        }
        ?>
        </div>
        <?php

        $show_notice=false;

        if($user_info===false)
        {
            $show_notice=true;
        }
        else
        {
            if($addons_cache!==false)
            {
                if(!$addons_cache['pro_user']||!$addons_cache['check_active'])
                {
                    $show_notice=true;
                }
            }
        }

        if($show_notice)
        {
            $show_time = get_option('wpvivid_active_info',false);
            if(time()>$show_time)
            {
                _e('<div class="notice notice-info" id="wpvivid_notice_rate">
                        <p>Would you like to upgrade to Pro version to get regular updates and unlock premium support? Please activate the text link below.</p>
                        <div style="padding-bottom: 10px;">
                            <span><input type="button" class="button-primary" option="wpvivid-active" name="active-now" value="Activate Now" /></span>
                            <span><input type="button" class="button-secondary" option="wpvivid-active" name="active-later" value="Activate Later" /></span>
                        </div>
                    </div>');
            }
        }

    }

    public function add_active_info()
    {
        if(isset($_POST['active-action']))
        {
            if($_POST['active-action']=='active-later')
            {
                update_option('wpvivid_active_info',time()+604800);
            }
            else
            {
                update_option('wpvivid_active_info',time());
            }

            $options=array();
            $options['timeout']=30;
            wp_remote_request('http://access.wpvivid.com?action='.$_POST['active-action'],$options);
        }
        die();
    }

    public function get_user_info()
    {
        $user_info=get_option('wpvivid_pro_user',false);
        return $user_info;
    }

    public function update_user_info($user_info)
    {
        update_option('wpvivid_pro_user',$user_info);
    }

    public function get_addons_cache()
    {
        $addons_cache=get_option('wpvivid_pro_addons_cache',false);
        if($addons_cache===false||empty($addons_cache))
        {
            return false;
        }
        return $addons_cache;
    }

    public function update_addons_cache($addons_cache)
    {
        update_option('wpvivid_pro_addons_cache',$addons_cache);
    }

    public function output_login_box($user_info,$auto_login)
    {
        $addons_cache=$this->get_addons_cache();
        $user_info=$this->get_user_info();
        $inactive=false;
        $membership = 'N/A';
        $activation_number = 'N/A';
        $expire = 'N/A';
        if($user_info===false) {
            $inactive=true;
            $membership = 'N/A';
            $activation_number = 'N/A';
            $expire = 'N/A';
        }
        else {
            if($addons_cache!==false) {
                if(!$addons_cache['pro_user']||!$addons_cache['check_active']) {
                    $inactive=true;
                }
                if(isset($addons_cache['memberships'])){
                    foreach ($addons_cache['memberships'] as $member => $value) {
                        $membership = $value['name'];
                        if($membership === 'WPvivid Backup Pro - Beta'){
                            $membership = 'WPvivid Backup Pro (Beta)';
                        }
                        $expire = $value['end_date'];
                        if($expire === 0){
                            $expire = '12-31-2019';
                        }
                    }
                }
                if(isset($addons_cache['total_activations']) && isset($addons_cache['total_activations_purchased'])){
                    $activation_number = $addons_cache['total_activations'] . '/' . $addons_cache['total_activations_purchased'];
                }
            }
        }
        if($inactive){
            $active_status = 'InActive';
        }
        else{
            $active_status = 'Active';
        }
        $version_compare = '';
        if(isset($addons_cache['pro'])&&is_array($addons_cache['pro']))
        {
            if(version_compare(WPVIVID_BACKUP_PRO_VERSION,$addons_cache['pro']['version'],'<'))
            {
                $version_compare = '<div style="float: left; color: #9e5c07; margin-left: 5px;"> (Latest Version Available: '.$addons_cache['pro']['version'].')</div>';
            }
        }

        ?>
        <div class="postbox quickbackup-addon" id="wpvivid_login_box">
            <table class="wp-list-table widefat plugins" style="width: 100%;">
                <tbody>
                <tr>
                    <td class="column-primary" style="margin: 10px;">
                        <div>
                            <img src="<?php echo esc_url(WPVIVID_BACKUP_PRO_PLUGIN_URL.'includes/images/pro.png'); ?>" style="width:100px; height:100px;">
                        </div>
                    </td>
                    <td class="column-description desc">
                        <div>
                            <form action="">
                                <div style="margin-top: 10px; margin-bottom: 15px;"><input type="text" class="regular-text" id="wpvivid_account_user" placeholder="Email" autocomplete="off" required /></div>
                                <div style="margin-bottom: 15px;"><input type="password" class="regular-text" id="wpvivid_account_pw" placeholder="Password" autocomplete="new-password" required /></div>
                                <div style="margin-bottom: 10px; float: left; margin-left: 0; margin-right: 10px;"><input class="button-primary" id="wpvivid_active_btn" type="button" value="Activate" onclick="wpvivid_connect_account_and_active(false);" /></div>
                                <div class="spinner" id="wpvivid_login_box_progress" style="float: left; margin-left: 0; margin-right: 10px;"></div>
                                <div style="float: left; margin-top: 4px;"><span id="wpvivid_log_progress_text"></span></div>
                                <div style="clear: both;"></div>
                            </form>
                            <div id="wpvivid_connect_result" style="display: none; margin-bottom: 10px;"></div>
                            <div style="background-color:#f5f5f5; padding:5px;">
                                <i>Tips: The email and password are the same as your registration on <a href="https://pro.wpvivid.com" target="_blank">pro.wpvivid.com</a>. You have to activate the installation to get update and support</i>
                            </div>
                        </div>
                    </td>
                    <td class="column-description desc">
                        <div style="padding-left: 5px;">
                            <div style="margin-bottom: 10px;"><strong>WPvivid Backup Pro</strong></div>
                            <div style="margin-bottom: 10px;"><i>WPvivid Backup Pro works on top of free version, providing a full flexibility and a series of robust customization options to meet your diversified website backup and migration needs.</i></div>
                        </div>
                        <div style="border-left:4px solid #00a0d2;padding-left:10px;">
                            <div>
                                <div style="margin-right: 5px; float: left; margin-bottom: 5px;">Current Version: </div><div style="float: left; margin-bottom: 5px;"><?php echo WPVIVID_BACKUP_PRO_VERSION; ?></div><?php _e($version_compare); ?>
                                <div style="clear: both;"></div>
                            </div>
                            <div>
                                <div style="margin-right: 5px; float: left; margin-bottom: 5px;">Membership Plan: </div><div style="float: left; margin-bottom: 5px;"><?php echo $membership; ?></div>
                                <div style="clear: both;"></div>
                            </div>
                            <div>
                                <div style="margin-right: 5px; float: left; margin-bottom: 5px;">Status: </div><div style="float: left; margin-bottom: 5px;"><?php echo $active_status; ?></div>
                                <div style="clear: both;"></div>
                            </div>
                            <div>
                                <div style="margin-right: 5px; float: left; margin-bottom: 5px;">Active Website(s): </div><div style="float: left;"><?php echo $activation_number; ?></div>
                                <div style="clear: both;"></div>
                            </div>
                            <div>
                                <div style="margin-right: 5px; float: left;">Expiration Date: </div><div style="float: left;"><?php echo $expire; ?></div>
                                <div style="clear: both;"></div>
                            </div>
                        </div>
                    </td>
                </tr>
                </tbody>
            </table>
        </div>
        <script>
        <?php
        if($auto_login)
        {
            ?>
            jQuery(document).ready(function ()
            {
                 wpvivid_connect_account(true);
            });
            <?php
        }
        ?>
        </script>
        <?php
    }

    public function output_userinfo($user_info,$addons_cache)
    {
        $addons_cache=$this->get_addons_cache();
        $user_info=$this->get_user_info();
        $inactive=false;
        $membership = 'N/A';
        $activation_number = 'N/A';
        $expire = 'N/A';
        if($user_info===false) {
            $inactive=true;
            $membership = 'N/A';
            $activation_number = 'N/A';
            $expire = 'N/A';
        }
        else {
            if($addons_cache!==false) {
                if(!$addons_cache['pro_user']||!$addons_cache['check_active']) {
                    $inactive=true;
                }
                if(isset($addons_cache['memberships'])){
                    foreach ($addons_cache['memberships'] as $member => $value) {
                        $membership = $value['name'];
                        if($membership === 'WPvivid Backup Pro - Beta'){
                            $membership = 'WPvivid Backup Pro (Beta)';
                        }
                        $expire = $value['end_date'];
                        if($expire === 0){
                            $expire = '12-31-2019';
                        }
                    }
                }
                if(isset($addons_cache['total_activations']) && isset($addons_cache['total_activations_purchased'])){
                    $activation_number = $addons_cache['total_activations'] . '/' . $addons_cache['total_activations_purchased'];
                }
            }
        }
        if($inactive){
            $active_status = 'InActive';
        }
        else{
            $active_status = 'Active';
        }
        $version_compare = '';
        if(isset($addons_cache['pro'])&&is_array($addons_cache['pro']))
        {
            if(version_compare(WPVIVID_BACKUP_PRO_VERSION,$addons_cache['pro']['version'],'<'))
            {
                $version_compare = '<div style="float: left; color: #9e5c07; margin-left: 5px;"> (Latest Version Available: '.$addons_cache['pro']['version'].')</div>';
            }
        }
        $b_has_update = false;
        ?>
        <div class="postbox quickbackup-addon" id="wpvivid_userinfo_box" style="padding-bottom: 0;">
            <div style="margin-bottom: 10px;">
                <table class="wp-list-table widefat plugins" style="width: 100%;">
                    <tbody>
                    <tr>
                        <td class="column-primary" style="margin: 10px;">
                            <div>
                                <img src="<?php echo esc_url(WPVIVID_BACKUP_PRO_PLUGIN_URL.'includes/images/pro.png'); ?>" style="width:100px; height:100px;">
                            </div>
                        </td>
                        <td class="column-description desc">
                            <div style="margin-top: 10px;">
                                <div style="margin-bottom: 10px;">
                                    <h3 style="margin: 0;">Hello <?php echo $user_info['email']?></h3>
                                </div>
                                <?php
                                if($addons_cache===false)
                                {
                                    ?>
                                    <div style="float: left; margin-bottom: 10px; margin-right: 10px;">
                                        Archieve user information failed, please refresh user information.
                                    </div>
                                    <div style="float: left; margin-bottom: 10px;">
                                        <a href="#" id="wpvivid_change_btn" onclick="wpvivid_change_user();">Switch Accounts</a>
                                    </div>
                                    <div style="clear: both;"></div>
                                    <div style="margin-bottom: 10px; float: left;">
                                        <input id="wpvivid_refresh_user_info" type="button" class="button-primary ud_connectsubmit" value="Refresh User information" onclick="wpvivid_check_pro_update();">
                                    </div>
                                    <?php
                                }
                                else
                                {
                                    if($addons_cache['pro_user']==1)
                                    {
                                        ?>
                                        <div style="float: left; margin-bottom: 10px; margin-right: 10px;">You are WPvivid Pro user<a href="https://pro.wpvivid.com" target="_blank"> Go to My Account</a></div>
                                        <div style="float: left; margin-bottom: 10px;">
                                            <a href="#" id="wpvivid_change_btn" onclick="wpvivid_change_user();">Switch Accounts</a>
                                        </div>
                                        <div style="clear: both;"></div>
                                        <?php

                                        if(!$addons_cache['check_active'])
                                        {
                                            $this->output_active_box();
                                        }
                                        else
                                        {
                                            ?>
                                            <div class="postbox" style="margin-bottom: 10px;">
                                                <div style="padding: 10px;">
                                                    <span><?php echo home_url()?> has been activated</span>
                                                </div>
                                            </div>
                                            <?php
                                            if(isset($addons_cache['addons'])&&is_array($addons_cache['addons'])) {
                                                foreach ($addons_cache['addons'] as $addon) {
                                                    $data = $this->addons->get_local_addon_data($addon['slug']);
                                                    if ($data === false) {
                                                        $b_has_update = true;
                                                    } else {
                                                        if ($addon['active']) {
                                                            if (version_compare($addon['version'], $data['Version'], '>')) {
                                                                $b_has_update = true;
                                                            }
                                                        }
                                                    }
                                                }
                                                if (version_compare(WPVIVID_BACKUP_PRO_VERSION, $addons_cache['pro']['version'], '<')) {
                                                    $b_has_update = true;
                                                }
                                            }
                                            if ($b_has_update) {
                                                ?>
                                                <div style="margin-bottom: 10px; float: left;">
                                                    <input id="wpvivid_update_all_btn" type="button"
                                                           class="button-primary ud_connectsubmit"
                                                           value="update pro & install all addons with one click"
                                                           onclick="wpvivid_click_update_all();">
                                                </div>
                                                <?php
                                            }
                                            else {
                                                ?>
                                                <div style="margin-bottom: 10px; float: left;">
                                                    <input id="wpvivid_check_pro_update_btn" type="button"
                                                           class="button-primary ud_connectsubmit" value="Check Update"
                                                           onclick="wpvivid_check_pro_update();">
                                                </div>
                                                <?php
                                            }
                                        }
                                    }
                                    else
                                    {
                                        ?>
                                        <div style="margin-bottom: 10px; float: left;">You are not pro user, get your <a href="https://pro.wpvivid.com" target="_blank">Pro version</a> Support</div>
                                        <?php
                                    }
                                }
                                ?>
                                <div class="spinner" id="wpvivid_user_info_box_progress" style="float: left;"></div>
                                <div style="clear: both;"></div>
                                <div id="wpvivid_action_result" style="display: none; margin-bottom: 10px;"></div>
                                <div style="background-color:#f5f5f5; padding:5px;">
                                    <i>Tips: The email and password are the same as your registration on <a href="https://pro.wpvivid.com" target="_blank">pro.wpvivid.com</a>. You have to activate the installation to get update and support</i>
                                </div>
                            </div>
                        </td>
                        <td class="column-description desc">
                            <div style="padding-left: 5px;">
                                <div style="margin-bottom: 10px;"><strong>WPvivid Backup Pro</strong></div>
                                <div style="margin-bottom: 10px;"><i>WPvivid Backup Pro works on top of free version, providing a full flexibility and a series of robust customization options to meet your diversified website backup and migration needs.</i></div>
                            </div>
                            <div style="border-left:4px solid #00a0d2;padding-left:10px;">
                                <div>
                                    <div style="margin-right: 5px; float: left; margin-bottom: 5px;">Current Version: </div><div style="float: left; margin-bottom: 5px;"><?php echo WPVIVID_BACKUP_PRO_VERSION; ?></div><?php _e($version_compare); ?>
                                    <div style="clear: both;"></div>
                                </div>
                                <div>
                                    <div style="margin-right: 5px; float: left; margin-bottom: 5px;">Membership Plan: </div><div style="float: left; margin-bottom: 5px;"><?php echo $membership; ?></div>
                                    <div style="clear: both;"></div>
                                </div>
                                <div>
                                    <div style="margin-right: 5px; float: left; margin-bottom: 5px;">Status: </div><div style="float: left; margin-bottom: 5px;"><?php echo $active_status; ?></div>
                                    <div style="clear: both;"></div>
                                </div>
                                <div>
                                    <div style="margin-right: 5px; float: left; margin-bottom: 5px;">Active Website(s): </div><div style="float: left;"><?php _e($activation_number); ?></div>
                                    <div style="clear: both;"></div>
                                </div>
                                <div>
                                    <div style="margin-right: 5px; float: left;">Expiration Date: </div><div style="float: left;"><?php echo $expire; ?></div>
                                    <div style="clear: both;"></div>
                                </div>
                            </div>
                        </td>
                    </tr>
                    </tbody>
                </table>
            </div>

            <?php
            if(isset($addons_cache['addons'])&&is_array($addons_cache['addons'])) {
                if ($this->addons->has_default_package()) {
                    ?>
                    <div id="wpvivid_addons_content">
                        <div class="postbox" style="margin-bottom: 10px;">
                            <div style="margin: 10px;">
                                    <table class="widefat updates-table">
                                        <thead>
                                        <tr>
                                            <td class="manage-column">
                                                <span>PRO</span>
                                            </td>
                                            <td class="manage-column">
                                                <span>Status</span>
                                            </td>
                                        </tr>
                                        </thead>
                                        <tbody class="plugins">
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>Custom database tables,Include/exclude folders
                                                        backup </strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>Create a staging or development enviroment</strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>Sending a staging or development enviroment to a remote
                                                        storage</strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>Backup plugins, themes or the WordPress core files before
                                                        updating</strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>Google Drive:Custom folder for each wordpress site</strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>Dropbox:Custom folder for each wordpress site</strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>Microsoft Onedrive:Custom folder for each wordpress
                                                        site</strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>Amason S3:Custom folder for each wordpress site</strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>DigitalOcean Space:Custom folder for each wordpress
                                                        site</strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>Custom content for each schedule</strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>Custom start time of schedule</strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>Restore what you want from a backup</strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>Migrate Wordpress site via uploading a backup to your remote
                                                        storage</strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>Custom email template.Sending email report to many email
                                                        address</strong>
                                                </p>
                                            </td>
                                            <td class="plugin-title">
                                                <p>
                                                    <strong>
                                                        active
                                                    </strong>
                                                </p>
                                            </td>
                                        </tr>
                                        </tbody>
                                    </table>
                                </div>
                        </div>
                    </div>
                    <?php
                }
            }
            ?>
        </div>
        <script>
            <?php
            if($user_info===false)
            {
            ?>
            jQuery('#wpvivid_login_box').show();
            jQuery('#wpvivid_userinfo_box').hide();
            <?php
            }
            else
            {
            ?>
            jQuery('#wpvivid_login_box').hide();
            jQuery('#wpvivid_userinfo_box').show();
            <?php
            }
            if($b_has_update){
            ?>
            jQuery('#wpvivid_has_update_pro').show();
            <?php
            }
            else{
            ?>
            jQuery('#wpvivid_has_update_pro').hide();
            <?php
            }
            ?>
        </script>
        <?php
    }

    public function output_addons_table($addons_cache)
    {
        ?>
        <div id="wpvivid_addons_content">
            <div class="postbox" style="margin: 10px;">
                <div class="inside">
                    <p>
                        <?php
                        $time=get_option('wpvivid_last_update_time',false);
                        if($time!==false)
                        {
                            echo '<span>Last checked update: '.date('M d, Y H:i',$time).'</span>';
                        }
                        ?>
                        <input id="wpvivid_check_pro_update_btn" type="button" class="button-primary ud_connectsubmit" value="Check Update" onclick="wpvivid_check_pro_update();">
                    </p>
            <?php
            if(isset($addons_cache['pro'])&&is_array($addons_cache['pro']))
            {
                ?>
                <div class="inside">
                    <div class="spinner" id="wpvivid_update_box_progress" style="float:right"></div>
                    <p><?php echo 'WPvivid Pro Version:'.WPVIVID_BACKUP_PRO_VERSION ;?></p>
                    <?php
                    if(version_compare(WPVIVID_BACKUP_PRO_VERSION,$addons_cache['pro']['version'],'>='))
                    {
                        echo '<p>Already the latest version</p>';
                    }
                    else
                    {
                        echo '<p>Have new version '.$addons_cache['pro']['version'].'</p>';
                    }
                    ?>
                </div>
                <?php
            }
            if(isset($addons_cache['addons'])&&is_array($addons_cache['addons']))
            {
                $b_has_update=false;
                foreach ($addons_cache['addons'] as $addon)
                {
                    $data=$this->addons->get_local_addon_data($addon['slug']);
                    if($data===false)
                    {
                        $b_has_update=true;
                    }
                    else
                    {
                        if($addon['active'])
                        {
                            if(version_compare($addon['version'],$data['Version'],'>'))
                            {
                                $b_has_update=true;
                            }
                        }
                    }
                }


                if($b_has_update)
                {
                    ?>
                    <p>
                        <input type="button" class="button-primary ud_connectsubmit" value="update pro & install all addons with one click" onclick="wpvivid_click_update_all()">
                    </p>
                    <?php
                }

                if($this->addons->has_default_package())
                {
                   ?>
                    <div class="inside">
                        <div class="spinner" id="wpvivid_update_addons_box_progress" style="float:right"></div>
                        <table class="widefat updates-table">
                            <thead>
                            <tr>
                                <td class="manage-column">
                                    <span>PRO</span>
                                </td>
                                <td class="manage-column">
                                    <span></span>
                                </td>
                            </tr>
                            </thead>
                            <tbody class="plugins">
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>Custom database tables,Include/exclude folders backup </strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>Create a staging or development enviroment</strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>Sending a staging or development enviroment to a remote storage</strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>Backup plugins, themes or the WordPress core files before updating</strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>Google Drive:Custom folder for each wordpress site</strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>Dropbox:Custom folder for each wordpress site</strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>Microsoft Onedrive:Custom folder for each wordpress site</strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>Amason S3:Custom folder for each wordpress site</strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>DigitalOcean Space:Custom folder for each wordpress site</strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>Custom content for each schedule</strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>Custom start time of schedule</strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>Restore what you want from a backup</strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>Migrate Wordpress site via uploading a backup to your remote storage</strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            <tr>
                                <td class="plugin-title">
                                    <p>
                                        <strong>Custom email template.Sending email report to many email address</strong>
                                    </p>
                                </td>
                                <td class="plugin-title">
                                    <p>
                                        <strong>
                                            active
                                        </strong>
                                    </p>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                    </div>
                    <?php
                }
                else
                {
                    ?>
                    <p>
                        <span>
                            Not found addons.Please click install all addons to get pro Features
                        </span>
                    </p>
                    <?php
                }
            }
            ?>
                </div>
            </div>
        </div>
        <?php
    }

    public function output_active_box()
    {
        ?>
        <div style="margin-bottom: 10px;">
            Your website has not been activated. You can install and update addon after activation site.
        </div>
        <div style="margin-bottom: 10px; float: left;">
            <input id="wpvivid_active_site_btn" type="button" class="button-primary ud_connectsubmit" value="Active your site" onclick="wpvivid_active_site();" />
        </div>
        <?php
    }

    public function connect_account()
    {
        try
        {
            if(isset($_POST['auto_login'])&&$_POST['auto_login']===true)
            {
                $encrypt_user_info=false;
                $get_key=false;
                $info=$this->get_user_info();
                if($info===false)
                {
                    $ret['result']='failed';
                    $ret['error']='Retrieving user information failed. Please try again later.';
                    echo json_encode($ret);
                    die();
                }
                $user_info=$info['password'];
            }
            else
            {
                $encrypt_user_info=true;
                $get_key=true;
                if(isset($_POST['user'])&&isset($_POST['password']))
                {
                    $email=sanitize_email($_POST['user']);
                    if(!is_email($email))
                    {
                        $ret['result']='failed';
                        $ret['error']='An email address is required.';
                        echo json_encode($ret);
                        die();
                    }

                    if(empty($_POST['password']))
                    {
                        $ret['result']='failed';
                        $ret['error']='A password is required.';
                        echo json_encode($ret);
                        die();
                    }
                    $user_info['email']=$email;
                    $user_info['password']=$_POST['password'];
                }
                else
                {
                    $ret['result']='failed';
                    $ret['error']='Retrieving user information failed. Please try again later.';
                    echo json_encode($ret);
                    die();
                }
            }

            $server=new WPvivid_Connect_server();
            $ret=$server->login($user_info,$encrypt_user_info,$get_key);
            if($ret['result']=='success')
            {
                if($ret['status']['pro_user'])
                {
                    $ret['pro_user']=1;
                    if($ret['status']['check_active'])
                    {
                        $ret['check_active']=1;
                    }
                    else
                    {
                        $ret['check_active']=0;
                    }

                    if(version_compare(WPVIVID_BACKUP_PRO_VERSION,$ret['status']['pro']['version'],'<'))
                    {
                        $ret['need_update']=1;
                    }
                    else
                    {
                        $ret['need_update']=0;
                    }

                    if(!$this->addons->has_default_package())
                    {
                        $ret['need_install']=1;
                    }
                    else
                    {
                        $ret['need_install']=0;
                    }
                }
                else
                {
                    $ret['pro_user']=0;
                    $ret['check_active']=0;
                }

                $info['email']=$user_info['email'];
                $info['password']=$ret['encrypt_user_info'];
                $this->update_user_info($info);
                $this->update_addons_cache($ret['status']);

                update_option('wpvivid_last_update_time',time());
            }

            echo json_encode($ret);
        }
        catch (Exception $e)
        {
            $ret['result']='failed';
            $ret['error']= $e->getMessage();
            echo json_encode($ret);
        }

        die();
    }

    public function connect_account_and_active()
    {
        try
        {
            $encrypt_user_info=true;
            $get_key=true;
            if(isset($_POST['user'])&&isset($_POST['password']))
            {
                $email=sanitize_email($_POST['user']);
                if(!is_email($email))
                {
                    $ret['result']='failed';
                    $ret['error']='The email address you entered is invalid. Please try again.';
                    echo json_encode($ret);
                    die();
                }

                if(empty($_POST['password']))
                {
                    $ret['result']='failed';
                    $ret['error']='A password is required.';
                    echo json_encode($ret);
                    die();
                }
                $user_info['email']=$email;
                $user_info['password']=$_POST['password'];
            }
            else
            {
                $ret['result']='failed';
                $ret['error']='Retrieving user information failed. Please try again later.';
                echo json_encode($ret);
                die();
            }

            set_time_limit(120);

            $server=new WPvivid_Connect_server();
            $ret=$server->active_site($user_info,$encrypt_user_info,$get_key);
            if($ret['result']=='success')
            {
                $info['email']=$user_info['email'];
                $info['password']=$ret['encrypt_user_info'];
                $this->update_user_info($info);
                $this->update_addons_cache($ret['status']);
                update_option('wpvivid_last_update_time',time());

                if($ret['status']['pro']!==false)
                {
                    if(version_compare(WPVIVID_BACKUP_PRO_VERSION,$ret['status']['pro']['version'],'<'))
                    {
                        $ret=$server->update_pro($info['password']);
                        if($ret['result']=='failed')
                        {
                            echo json_encode($ret);
                            die();
                        }
                    }
                }

                if(!$this->addons->has_default_package())
                {
                    $packages=$this->addons->get_default_package();
                    foreach ($packages as $slug=>$package)
                    {
                        $ret=$server->install_addon($info['password'],$slug);
                        if($ret['result']=='failed')
                        {
                            echo json_encode($ret);
                            die();
                        }
                    }
                }
            }

            echo json_encode($ret);
        }
        catch (Exception $e)
        {
            $ret['result']='failed';
            $ret['error']= $e->getMessage();
            echo json_encode($ret);
        }

        die();
    }

    public function check_pro_update()
    {
        try
        {
            $info=$this->get_user_info();
            if($info===false)
            {
                $ret['result']='failed';
                $ret['error']='Retrieving user information failed. Please try again later.';
                echo json_encode($ret);
                die();
            }

            $server=new WPvivid_Connect_server();
            $ret=$server->login($info['password'],false);

            if($ret['result']=='success')
            {
                $this->update_addons_cache($ret['status']);
                update_option('wpvivid_last_update_time',time());
            }
            else
            {
                $this->handle_server_error($ret);
            }

            echo json_encode($ret);
        }
        catch (Exception $e)
        {
            $ret['result']='failed';
            $ret['error']= $e->getMessage();
            echo json_encode($ret);
        }

        die();
    }

    public function active_site()
    {
        try
        {
            $info=$this->get_user_info();
            if($info===false)
            {
                $ret['result']='failed';
                $ret['error']='Retrieving user information failed. Please try again later.';
                echo json_encode($ret);
                die();
            }

            $server=new WPvivid_Connect_server();
            $ret=$server->active_site($info['password']);

            if($ret['result']=='success')
            {
                $this->update_addons_cache($ret['status']);

                update_option('wpvivid_last_update_time',time());

                if($ret['status']['pro']!==false)
                {
                    if(version_compare(WPVIVID_BACKUP_PRO_VERSION,$ret['status']['pro']['version'],'<'))
                    {
                        $ret=$server->update_pro($info['password']);
                        if($ret['result']=='failed')
                        {
                            echo json_encode($ret);
                            die();
                        }
                    }
                }

                if(!$this->addons->has_default_package())
                {
                    $packages=$this->addons->get_default_package();
                    foreach ($packages as $slug=>$package)
                    {
                        $ret=$server->install_addon($info['password'],$slug);
                        if($ret['result']=='failed')
                        {
                            echo json_encode($ret);
                            die();
                        }
                    }
                }
            }

            echo json_encode($ret);
        }
        catch (Exception $e)
        {
            $ret['result']='failed';
            $ret['error']= $e->getMessage();
            echo json_encode($ret);
        }

        die();
    }

    public function add_addon_tab()
    {
        $html=' <a href="#" id="wpvivid_tab_pro" class="nav-tab wrap-nav-tab" onclick="switchTabs(event,\'pro-page\')">Pro
                <span class="wpvivid-pro-update" id="wpvivid_has_update_pro" style="display: none;">
                    <span>Update</span>
                </span>
                </a>';
        echo $html;
    }

    public function update_all()
    {
        try
        {
            set_time_limit(120);
            $info=$this->get_user_info();
            if($info===false)
            {
                $ret['result']='failed';
                $ret['error']='Retrieving user information failed. Please try again later.';
                echo json_encode($ret);
                die();
            }
            $server=new WPvivid_Connect_server();

            $addons_cache=$this->get_addons_cache();
            if(version_compare(WPVIVID_BACKUP_PRO_VERSION,$addons_cache['pro']['version'],'<'))
            {
                $ret=$server->update_pro($info['password']);
                if($ret['result']=='failed')
                {
                    echo json_encode($ret);
                    die();
                }
            }

            foreach ($addons_cache['addons'] as $addon)
            {
                if ($addon['active'])
                {
                    $ret=$server->install_addon($info['password'],$addon['slug']);

                    echo json_encode($ret);
                    die();
                }
            }

            $ret['result']='failed';
            $ret['error']='Sorry, something went wrong. Please try again later or contact us.';
            echo json_encode($ret);
            die();
        }
        catch (Exception $e)
        {
            $ret['result']='failed';
            $ret['error']=$e->getMessage();
            echo json_encode($ret);
        }

        die();
    }

    public function update_addon()
    {
        try
        {
            $info=$this->get_user_info();
            if($info===false)
            {
                $ret['result']='failed';
                $ret['error']='Retrieving user information failed. Please try again later.';
                echo json_encode($ret);
                die();
            }
            $server=new WPvivid_Connect_server();

            $ret=$server->install_addon($info['password'],$_POST['slug']);

            echo json_encode($ret);
        }
        catch (Exception $e)
        {
            echo $e->getMessage();
        }

        die();
    }

    public function handle_server_error($error)
    {
        if(isset($error['error_code']))
        {
            if($error['error_code']==109||$error['error_code']==108||$error['error_code']==107)
            {
                delete_option('wpvivid_pro_user');
                delete_option('wpvivid_pro_addons_cache');
            }
        }

        update_option('wpvivid_connect_server_last_error',$error['error']);
    }

    public function check_wpvivid_plugin_active()
    {
        $active_plugins = get_option('active_plugins');
        if(!function_exists('get_plugins'))
            require_once(ABSPATH . 'wp-admin/includes/plugin.php');
        $plugins=get_plugins();
        $free_wpvivid_slug='wpvivid-backuprestore/wpvivid-backuprestore.php';
        if(!empty($plugins))
        {
            if(isset($plugins[$free_wpvivid_slug]))
            {
                if(version_compare('0.9.25',$plugins[$free_wpvivid_slug]['Version'],'>'))
                {
                    ?>
                    <div class="notice notice-warning inline" style="padding: 11px 15px; margin: 10px 20px 10px 2px;">
                        The free version of WPvivid Backup Plugin is required higher version to use WPvivid Backup pro. Please update the free version first.
                    </div>
                    <?php
                }
                ?>
                <?php
                if(!in_array($free_wpvivid_slug, $active_plugins))
                {
                    ?>
                    <div class="notice notice-warning inline" style="padding: 11px 15px; margin: 10px 20px 10px 2px;">
                        The free version of WPvivid Backup Plugin is required to use WPvivid Backup Pro. Please activate the free version first.
                    </div>
                    <?php
                }
            }
            else
            {
                ?>
                <div class="notice notice-warning inline" style="padding: 11px 15px; margin: 10px 20px 10px 2px;">
                    The free version of WPvivid Backup Plugin is required to use WPvivid Backup Pro. Please install and activate the free version first. Click <a href="<?php esc_attr_e(admin_url().'plugin-install.php?s=WPvivid&tab=search&type=term'); ?>">here</a> to install.
                </div>
                <?php
            }
        }
    }
}



