<?php

class WPvivid_Connect_server
{
    private $url='https://pro.wpvivid.com/wc-api/wpvivid_api';
    //private $url='http://localhost/wordpress/wpvivid/wc-api/wpvivid_api';
    private $update_url='http://download.wpvivid.com';
    private $public_key;

    public function __construct()
    {
        /*
        if(empty($instance))
        {
            $permalink = get_permalink();
            $find = array( 'http://', 'https://' );
            $replace = '';
            $this->instance = md5(str_replace( $find, $replace, $permalink ));
            update_option('wpvivid_instance',$this->instance);
        }
        else
        {
            $this->instance=$instance;
        }*/
    }

    public function login($user_info,$encrypt_user_info,$get_key=false)
    {
        if($get_key)
            $public_key='';
        else
        $public_key=get_option('wpvivid_connect_key','');

        if(empty($public_key))
        {
            $public_key=$this->get_key();
            if($public_key===false)
            {
                $ret['result']='failed';
                $ret['error']='An error occurred when connecting to WPvivid Backup Pro server. Please try again later or contact us.';
                return $ret;
            }
            update_option('wpvivid_connect_key',$public_key);
        }

        $crypt=new WPvivid_crypt($public_key);

        if($encrypt_user_info)
        {
            $encrypt_user_info=$crypt->encrypt_user_info($user_info['email'],$user_info['password']);
            $encrypt_user_info=base64_encode($encrypt_user_info);
        }
        else
        {
            $encrypt_user_info=$user_info;
        }

        $crypt->generate_key();
        $key=$crypt->encrypt_key();

        $json['user_info']=$encrypt_user_info;
        $json['domain'] =home_url();
        $json=json_encode($json);
        $data=$crypt->encrypt_message($json);

        $action='get_status';
        $url=$this->url;
        $url.='?request='.$action;
        $url.='&data='.rawurlencode(base64_encode($data));
        $options=array();
        $options['timeout']=30;
        $request=wp_remote_request($url,$options);

        if(!is_wp_error($request) && ($request['response']['code'] == 200))
        {
            $json= wp_remote_retrieve_body($request);
            $body=json_decode($json,true);
            if(is_null($body))
            {
                $ret['result']='failed';
                $ret['error']='Decoding json failed. Please try again later.';
                $ret['test']=$json;
                return $ret;
            }
            $body['encrypt_user_info']=$encrypt_user_info;
            return $body;
        }
        else
        {
            $ret['result']='failed';
            if ( is_wp_error( $request ) )
            {
                $error_message = $request->get_error_message();
                $ret['error']="Sorry, something went wrong: $error_message. Please try again later or contact us.";
            } else {
                $ret['error']=$request;
            }
            return $ret;
        }
    }

    public function active_site($user_info,$encrypt_user_info=false,$get_key=false)
    {
        if($get_key)
            $public_key='';
        else
            $public_key=get_option('wpvivid_connect_key','');

        if(empty($public_key))
        {
            $public_key=$this->get_key();
            if($public_key===false)
            {
                $ret['result']='failed';
                $ret['error']='An error occurred when connecting to WPvivid Backup Pro server. Please try again later or contact us.';
                return $ret;
            }
            update_option('wpvivid_connect_key',$public_key);
        }

        $crypt=new WPvivid_crypt($public_key);

        if($encrypt_user_info)
        {
            $encrypt_user_info=$crypt->encrypt_user_info($user_info['email'],$user_info['password']);
            $encrypt_user_info=base64_encode($encrypt_user_info);
        }
        else
        {
            $encrypt_user_info=$user_info;
        }

        $crypt->generate_key();
        $key=$crypt->encrypt_key();

        $json['user_info']=$encrypt_user_info;
        $json['domain'] =home_url();
        $json=json_encode($json);
        $data=$crypt->encrypt_message($json);

        $action='active_site';
        $url=$this->url;
        $url.='?request='.$action;
        $url.='&data='.rawurlencode(base64_encode($data));
        $options=array();
        $options['timeout']=30;
        $request=wp_remote_request($url,$options);

        if(!is_wp_error($request) && ($request['response']['code'] == 200))
        {
            $json= wp_remote_retrieve_body($request);
            $body=json_decode($json,true);
            if(is_null($body))
            {
                $ret['result']='failed';
                $ret['error']=$json;
                return $ret;
            }
            $body['encrypt_user_info']=$encrypt_user_info;
            return $body;
        }
        else
        {
            $ret['result']='failed';
            if ( is_wp_error( $request ) )
            {
                $error_message = $request->get_error_message();
                $ret['error']="Sorry, something went wrong: $error_message. Please try again later or contact us.";
            } else {
                $ret['error']=$request;
            }
            return $ret;
        }
    }

    public function install_addon($user_info,$slug)
    {
        $public_key=get_option('wpvivid_connect_key','');
        if(empty($public_key))
        {
            $public_key=$this->get_key();
            if($public_key===false)
            {
                $ret['result']='failed';
                $ret['error']='An error occurred when connecting to WPvivid Backup Pro server. Please try again later or contact us.';
                return $ret;
            }
            update_option('wpvivid_connect_key',$public_key);
        }

        $crypt=new WPvivid_crypt($public_key);

        $crypt->generate_key();
        $key=$crypt->encrypt_key();

        $json['user_info']=$user_info;
        $json['domain'] =home_url();
        $json['slug']=$slug;
        $json=json_encode($json);
        $data=$crypt->encrypt_message($json);

        $url=$this->update_url;
        $data=base64_encode($data);
        $options=array();
        $options['body']['data']=$data;
        $options['timeout']=30;
        $request=wp_remote_post($url,$options);

        if(!is_wp_error($request) && ($request['response']['code'] == 200))
        {
            $json= wp_remote_retrieve_body($request);
            $body=json_decode($json,true);
            if(is_null($body))
            {
                $ret['result']='failed';
                $ret['error']=$json;
                return $ret;
            }

            $data=base64_decode($body['data']);
            $data=$crypt->decrypt_message($data);

            $params=json_decode($data,1);
            if(is_null($params))
            {
                $ret['result']='failed';
                $ret['error']='Dectypting data failed. Please try again later.';
                $ret['data']=$body['data'];
                return $ret;
            }
            else
            {
                $path=WPVIVID_BACKUP_PRO_PLUGIN_DIR.'/addons/'.$params['file_name'];
                @unlink($path);

                file_put_contents($path,base64_decode($params['content']));

                if (!class_exists('PclZip'))
                    include_once(ABSPATH.'/wp-admin/includes/class-pclzip.php');
                $archive = new PclZip($path);

                $zip_ret = $archive->extract(PCLZIP_OPT_PATH,dirname($path),PCLZIP_OPT_REPLACE_NEWER);

                if(!$zip_ret)
                {
                    $ret['result']='failed';
                    $ret['error'] = $archive->errorInfo(true);
                }
                else
                {
                    @unlink($path);
                    $ret['result']='success';
                }

                return $ret;
            }
        }
        else
        {
            $ret['result']='failed';
            if ( is_wp_error( $request ) )
            {
                $error_message = $request->get_error_message();
                $ret['error']="Sorry, something went wrong: $error_message. Please try again later or contact us.";
            } else {
                $ret['error']=$request;
            }
            return $ret;
        }
    }

    public function update_pro($user_info)
    {
        $public_key=get_option('wpvivid_connect_key','');
        if(empty($public_key))
        {
            $public_key=$this->get_key();
            if($public_key===false)
            {
                $ret['result']='failed';
                $ret['error']='An error occurred when connecting to WPvivid Backup Pro server. Please try again later or contact us.';
                return $ret;
            }
            update_option('wpvivid_connect_key',$public_key);
        }

        $crypt=new WPvivid_crypt($public_key);

        $crypt->generate_key();
        $key=$crypt->encrypt_key();

        $json['user_info']=$user_info;
        $json['domain'] =home_url();
        $json['slug']='wpvivid-backup-pro';
        $json=json_encode($json);
        $data=$crypt->encrypt_message($json);

        $url=$this->update_url;
        $data=base64_encode($data);
        $options=array();
        $options['body']['data']=$data;
        $options['timeout']=30;
        $request=wp_remote_post($url,$options);

        if(!is_wp_error($request) && ($request['response']['code'] == 200))
        {
            $json= wp_remote_retrieve_body($request);
            $body=json_decode($json,true);
            if(is_null($body))
            {
                $ret['result']='failed';
                $ret['error']=$json;
                return $ret;
            }

            $data=base64_decode($body['data']);
            $data=$crypt->decrypt_message($data);

            $params=json_decode($data,1);
            if(is_null($params))
            {
                $ret['result']='failed';
                $ret['error']='Decrypting data failed. Please try again later.';
                $ret['data']=$body['data'];
                return $ret;
            }
            else
            {
                $path=WPVIVID_BACKUP_PRO_PLUGIN_DIR.DIRECTORY_SEPARATOR.$params['file_name'];
                @unlink($path);

                file_put_contents($path,base64_decode($params['content']));

                if (!class_exists('PclZip'))
                    include_once(ABSPATH.'/wp-admin/includes/class-pclzip.php');
                $archive = new PclZip($path);

                $zip_ret = $archive->extract(PCLZIP_OPT_PATH,dirname($path),PCLZIP_OPT_REPLACE_NEWER,PCLZIP_OPT_REMOVE_PATH,'wpvivid-backup-pro');

                if(!$zip_ret)
                {
                    $ret['result']='failed';
                    $ret['error'] = $archive->errorInfo(true);
                }
                else
                {
                    @unlink($path);
                    $ret['result']='success';
                }

                return $ret;
            }
        }
        else
        {
            $ret['result']='failed';
            if ( is_wp_error( $request ) )
            {
                $error_message = $request->get_error_message();
                $ret['error']="Sorry, something went wrong: $error_message. Please try again later or contact us.";
            } else {
                $ret['error']=$request;
            }
            return $ret;
        }
    }

    public function check_connect()
    {
        $key=get_option('wpvivid_connect_key','');
        if(empty($key))
        {
            $key=$this->get_key();
            if($key===false)
            {
                $ret['result']='failed';
                $ret['error']='An error occurred when connecting to WPvivid Backup Pro server. Please try again later or contact us.';
                return $ret;
            }
            update_option('wpvivid_connect_key',$key);
        }

        $user_info=get_option('wpvivid_pro_user',array());
        if(empty($user_info))
        {
            $ret['result']='success';
            $ret['init']=false;
            return $ret;
        }

        $ret['result']='success';
        $ret['init']=true;
        return $ret;
    }

    public function set_key($public_key)
    {
        $this->public_key=$public_key;
    }

    public function get_key()
    {
        $options=array();
        $options['timeout']=30;
        $request=wp_remote_request($this->url.'?request=get_key',$options);

        if(!is_wp_error($request) && ($request['response']['code'] == 200))
        {
            $json= wp_remote_retrieve_body($request);
            $body=json_decode($json,true);
            if(is_null($body))
            {
               return false;
            }

            if($body['result']=='success')
            {
                $public_key=base64_decode($body['public_key']);
                if($public_key==null)
                {
                    return false;
                }
                else
                {
                    return $public_key;
                }
            }
            else
            {
                return false;
            }
        }
        else
        {
            return false;
        }
    }
}