<?php

define('WPVIVID_CHECK_UPDATE_URL','http://localhost/html/wordpress/wc-api/wpvivid_api?request=check_update');

class WPvivid_Update_Checker
{
    private $plug_name;
    private $version;

    public function __construct()
    {
        $this->plug_name=WPVIVID_PLUGIN_NAME;
        $this->version=WPVIVID_PLUGIN_VERSION;
        //add_filter('pre_set_site_transient_update_plugins', array($this, 'wpvivid_update_checker'), 11);
        //add_filter('wpvivid_pre_check_backup_options', array($this, 'pre_check_backup_options'));
        //add_filter('wpvivid_check_backup_options_valid',array($this,'check_backup_options_valid'),10);
        //add_filter('wpvivid_check_backup_options_valid',array($this,'check_backup_options_valid1'),11);
        //add_filter('wpvivid_check_backup_options_valid',array($this,'check_backup_options_valid2'),12);
    }

    public function wpvivid_update_checker($updates)
    {
        if ( isset( $updates->response[ $this->plug_name ] ) )
        {
            $plugin=$updates->response[ $this->plug_name ];
            unset($updates->response[ $this->plug_name ]);
        }
        else if(isset($updates->no_update[$this->plug_name]))
        {
            $plugin=$updates->no_update[ $this->plug_name ];
            unset($updates->no_update[ $this->plug_name ]);
        }
        else
        {
            $plugin=false;
        }
        $update_plugin=$this->check_update();

        if($update_plugin!==false)
        {
            if($plugin===false)
            {
                $updates->response[ $this->plug_name ]=$update_plugin;
            }
            else
            {
                $plugin->new_version=$update_plugin->new_version;
                $plugin->package=$update_plugin->package;
                $updates->response[ $this->plug_name ]=$plugin;
            }
        }

        return $updates;
    }

    private function check_update()
    {
        $wp_args['timeout'] = 15;
        $url=WPVIVID_CHECK_UPDATE_URL;
        $url.='&plugin='.$this->plug_name;
        $url.='&version='.$this->version;
        $request=wp_remote_request($url,$wp_args);

        if(!is_wp_error($request) && ($request['response']['code'] == 200))
        {
            $body= wp_remote_retrieve_body($request);
            $json=json_decode($body,true);
            if($json==null)
            {
                return false;
            }

            if($json['result']=='success')
            {
                if($json['update']==1)
                {
                    $item = $json['plugin'];
                    return (object) $item;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }
        }
        else
        {
            return false;
        }
    }

    public function check_backup_options_valid($backup_options)
    {
        if(!isset($backup_options['test']))
        {
            $backup_options['test']=1;
            echo '1';
        }
        return $backup_options;
    }

    public function check_backup_options_valid1($backup_options)
    {
        if(isset($backup_options['test']))
        {
            $backup_options['test']=2;
            echo '2';
        }
        return $backup_options;
    }

    public function check_backup_options_valid2($backup_options)
    {
        if(isset($backup_options['test']))
        {
            echo $backup_options['test'];
        }
        return false;
    }

    public function pre_check_backup_options($backup_options)
    {
        $backup_options['test']=1;
        return $backup_options;
    }
}