<?php

/**
 * @link              https://wpvivid.com
 * @since             1.9.0
 * @package           wpvivid
 *
 * @wordpress-plugin
 * Plugin Name:       WPvivid Backup Pro
 * Description:       WPvivid Backup Pro works on top of the free version. It offers more advanced features for customizing WordPress website backup and migration.
 * Version:           1.9.0
 * Author:            wpvivid.com
 * Author URI:        https://wpvivid.com
 * License:           GPL-3.0+
 * License URI:       http://www.gnu.org/copyleft/gpl.html
 * Text Domain:       wpvivid
 * Domain Path:       /languages
 */
define('WPVIVID_BACKUP_PRO_PLUGIN_DIR',dirname(__FILE__));
define('WPVIVID_BACKUP_PRO_PLUGIN_URL',plugin_dir_url(__FILE__));
define('WPVIVID_BACKUP_PRO_VERSION','1.9.0');
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) )
{
    die;
}

function wpvivid_pro_plugin_activate()
{
    $active_plugins = get_option('active_plugins');
    if(!function_exists('get_plugins'))
        require_once(ABSPATH . 'wp-admin/includes/plugin.php');
    $plugins=get_plugins();
    $free_wpvivid_slug='wpvivid-backuprestore/wpvivid-backuprestore.php';
    if(!empty($plugins))
    {
        if(isset($plugins[$free_wpvivid_slug]))
        {
            if(in_array($free_wpvivid_slug, $active_plugins))
            {
                add_option('wpvivid_pro_do_activation_redirect', true);
            }
        }
    }
}

function wpvivid_pro_init_plugin_redirect()
{
    if (get_option('wpvivid_pro_do_activation_redirect', false))
    {
        delete_option('wpvivid_pro_do_activation_redirect');
        wp_redirect(admin_url().'admin.php?page=WPvivid&tab-pro');
    }
}

register_activation_hook(__FILE__, 'wpvivid_pro_plugin_activate');
add_action('admin_init', 'wpvivid_pro_init_plugin_redirect');

require WPVIVID_BACKUP_PRO_PLUGIN_DIR . '/includes/class-wpvivid-backup-pro.php';

function run_wpvivid_backup_pro()
{
    $wpvivid_backup_pro=new WPvivid_backup_pro();
    $GLOBALS['wpvivid_backup_pro'] = $wpvivid_backup_pro;
}
run_wpvivid_backup_pro();